<template>
  <div>
    <!--引用表格-->
   <BasicTable @register="registerTable" >
     <!--插槽:table标题-->
       <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
      <!--字段回显插槽-->
      <template #htmlSlot="{text}">
         <div v-html="text"></div>
      </template>
      <!--省市区字段回显插槽-->
      <template #pcaSlot="{text}">
         {{ getAreaTextByCode(text) }}
      </template>
      <template #fileSlot="{text}">
         <span v-if="!text" style="font-size: 12px;font-style: italic;">无文件</span>
         <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)">下载</a-button>
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    
    <StProjectExecOneModal @register="registerModal" @success="handleSuccess" @callBack="rbckHandler"></StProjectExecOneModal>
  </div>
</template>

<script lang="ts" name="compliane.item-StProjectExecOne" setup>
  import { message } from 'ant-design-vue';
import { ref } from 'vue';
import { useRouter } from 'vue-router';
import { batchDelete, deleteOne, getExportUrl, getImportUrl, list } from './StProjectExecOne.api';
import { columns } from './StProjectExecOne.data';
import StProjectExecOneModal from './components/StProjectExecOneModal.vue';
import { useModal } from '/@/components/Modal';
import { BasicTable, TableAction } from '/@/components/Table';
import { useListPage } from '/@/hooks/system/useListPage';
import { downloadFile } from '/@/utils/common/renderUtils';
 const router = useRouter()
  const showBtn = ref(false)
  const checkedKeys = ref<Array<string | number>>([]);
  const emit = defineEmits(['success']);
  //注册model
  const [registerModal, {openModal}] = useModal();
  const [registerJCModal, {openModal:openModalJC}] = useModal();
  const props = defineProps({
    record: {}
  });
  //注册table数据
  const { prefixCls,tableContext,onExportXls,onImportXls } = useListPage({
      tableProps:{
           title: '',
           api: list,
           columns,
           canResize:false,
           showTableSetting: false,
           useSearchForm: false,
           immediate: false,
          //  formConfig: {
          //     //labelWidth: 120,
          //     schemas: searchFormSchema,
          //     autoSubmitOnEnter:true,
          //     showAdvancedButton:true,
          //     fieldMapToNumber: [
          //     ],
          //     fieldMapToTime: [
          //     ],
          //   },
           actionColumn: {
               width: 200,
               fixed:'right'
            },
            beforeFetch(params) {
              params = Object.assign(params,{ column: 'updatedTime', order: 'desc' })
            },
      },
       exportConfig: {
            name:"",
            url: getExportUrl,
          },
          importConfig: {
            url: getImportUrl,
            success: handleSuccess
          },
  })

  const [registerTable, {reload,setProps},{ rowSelection, selectedRowKeys }] = tableContext

  function goToCa(record){
    if(record.caName=="-"){
      return
    }
    router.push({path: '/standardlib/controlactivity/StCaMainList',query:{bizNo: record.caNo}})
  }
  function rbckHandler(data){
    reload();
   }
  function joinCheckHandler(){
      let caNos = selectedRowKeys.value
      console.log(caNos)
      if(!caNos||caNos.length==0){
        message.warning('请选择条目！');
        return;
      }
      openModalJC(true, {
          record: {caNos:caNos,type:'complianeItem'},
          isUpdate: false,
          showFooter: true,
        });
    }
   /**
    * 新增事件
    */
  function handleAdd() {
     openModal(true, {
       isUpdate: false,
       showFooter: true,
     });
  }
   /**
    * 编辑事件
    */
  function handleEdit(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: true,
     });
   }
   /**
    * 详情
   */
  function handleDetail(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }
   /**
    * 删除事件
    */
  async function handleDelete(record) {
     await deleteOne({id: record.id}, handleSuccess);
   }
   /**
    * 批量删除事件
    */
  async function batchHandleDelete() {
     await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
   }
   /**
    * 成功回调
    */
  function handleSuccess() {
      (selectedRowKeys.value = []) && reload();
      emit('success')
   }
   /**
      * 操作栏
      */
  function getTableAction(record){
       return [
         {
           label: '填报',
           onClick: handleEdit.bind(null, record),
         },
         {
           label: '查看',
           onClick: handleDetail.bind(null, record),
         }, 
       ]
   }
     /**
        * 下拉操作栏
        */
  function getDropDownAction(record){
       return [
       ]
   }

   defineExpose({setProps,reload})
</script>

<style scoped>

</style>